﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;

namespace DirectShowDemo
{
    public class CameraService
    {
        private static List<Camera> _availableCameras;
        private static CameraMethods _cameraMethods;

        private static CameraMethods CameraMethods
        {
            get
            {
                if (_cameraMethods == null)
                {
                    _cameraMethods = new CameraMethods();
                }

                return _cameraMethods;
            }
        }
        
        public static IEnumerable<Camera> AvailableCameras
        {
            get
            {
                if (_availableCameras == null)
                {
                    _availableCameras = BuildCameraList().ToList();
                }

                return _availableCameras;
            }
        }

        private static IEnumerable<Camera> BuildCameraList()
        {
            for (int i = 0; i < CameraMethods.Count; i++)
            {
                Camera cam = CameraMethods.GetCamera(i);
                if (cam != null)
                {
                    yield return cam;
                }
            }
        }
    }
}
