﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.InteropServices;

namespace DirectShowDemo
{
    public static class NativeMethods
    {
        [DllImport("VideoCamLib.dll", EntryPoint = "Initialize")]
        public static extern int VideoCamInitialize();

        [DllImport("VideoCamLib.dll", EntryPoint = "Cleanup")]
        public static extern int VideoCamCleanup();

        [DllImport("VideoCamLib.dll", EntryPoint = "RefreshCameraList")]
        public static extern int VideoCamRefreshCameraList(ref int count);

        [DllImport("VideoCamLib.dll", EntryPoint = "GetCameraDetails")]
        public static extern int VideoCamGetCameraDetails(int index,
            [Out, MarshalAs(UnmanagedType.Interface)] out object nativeInterface,
            out IntPtr name);

        public delegate void CaptureCallbackProc(
                int dwSize,
                [MarshalAs(UnmanagedType.LPArray, ArraySubType = UnmanagedType.I1, SizeParamIndex = 0)] byte[] abData);

        [DllImport("VideoCamLib.dll", EntryPoint = "StartCamera")]
        public static extern int VideoCamStartCamera(
            [In, MarshalAs(UnmanagedType.Interface)] object nativeInterface,
            CaptureCallbackProc lpCaptureFunc,
            int sminwidth,
            int minheight,
            ref int width,
            ref int height,
            ref int stride
            );

        [DllImport("VideoCamLib.dll", EntryPoint = "StartVideoFile")]
        public static extern int VideoCamStartVideoFile(
            [In, MarshalAs(UnmanagedType.LPWStr)] StringBuilder wFileName,
            CaptureCallbackProc lpCaptureFunc,
            ref int width,
            ref int height,
            ref int stride
            );

        [DllImport("VideoCamLib.dll", EntryPoint = "StopCamera")]
        public static extern int VideoCamStopCamera();

        [DllImport("VideoCamLib.dll", EntryPoint = "DisplayCameraPropertiesDialog")]
        public static extern int VideoCamDisplayCameraPropertiesDialog(
            [In, MarshalAs(UnmanagedType.Interface)] object nativeInterface,
            IntPtr hwnd);
    }
}
